#ifndef _FUNCTION_OBJECTS_H_
#define _FUNCTION_OBJECTS_H_


namespace SCE {


/*
 * Sums up the elements passed in.
 */
template <class T>
class SumUp
{
	
private:
	T sum;	
public:
	SumUp() { sum = 0; }	
	void operator() (T const & value) { sum += value; }
	T const & getSum() { return sum; }
	void reset() { sum = 0; }	
};

/*
 * Returns true if the element passed in is less than the value set in the
 * contructor.
 */
template <class T>
class LessThan
{
	
private:
	T number;
public:
	LessThan(T const & value) { number = value; }	
	bool operator() (T const & value) { return  value < number; }
};

}  // namespace SCE

#endif  /* _FUNCTION_OBJECTS_H_ */
